import random

def generate_random_binary_tree(seed):
    random.seed(seed)
    tree = [random.randint(1, 100000000) for i in range(20)]
    def compute_sum(root):
        if root >= len(tree):
            return 0
        left = 2*root + 1
        right = 2*root + 2
        res = compute_sum(left) + compute_sum(right)
        if res == 0:
            res = tree[root]
        tree[root] = res
        return res
    compute_sum(0)
    
    tree_order = []
    def tree_collect(root, indent=0):
        if root >= len(tree):
            return
        #print "-"*indent + str(tree[root])
        print tree[root]
        tree_order.append(tree[root])
        tree_collect(2*root+1, indent+1)
        tree_collect(2*root+2, indent+1)
    tree_collect(0)
    return tree_order

def generate_via_indents(seed):
    random.seed(seed)
    indents = [0]
    while len(indents) < 20:
        indents.append(random.randint(1, indents[-1]+1))
    values = [random.randint(1, 100000000) for i in range(20)]
    #values = [random.randint(1, 5) for i in range(20)]
    
    def children(idx):
        parent_level = indents[idx]
        child_idx = idx + 1
        while child_idx < len(values) and indents[child_idx] > parent_level:
            if indents[child_idx] == parent_level+1:
                yield child_idx
            child_idx += 1
    
    def compute_sum(root):
        cs = list(children(root))
        if len(cs) != 0:
            values[root] = sum([compute_sum(c) for c in cs])
        return values[root]
    compute_sum(0)
    return values
