#include<iostream>
#include<fstream>
#include<cmath>
#include<cstdlib>
using namespace std;

void quit(int score, const char* message) {
    cerr << message << "\n";
    cout << score << "\n";
    exit(0);
}

int main(int argc, char ** args) {
	if(argc != 4) {
		cerr << "Invalid no. of arguments. Usage:\n" << args[0] << " [input file] [correct solution] [solution to test]\n";
		return 0;
	}
	
	ifstream in(args[1]), cor(args[2]), out(args[3]);
    
    // Read three numbers from correct input and make sure they are equal up to 0.0001
	float c, o;
    for (int i = 0; i < 3; i++) {
        cor >> c;
        out >> o;
        if (out.fail()) quit(0, "Invalid format");
        if (abs(c - o) > 0.0001) quit(0, "Wrong answer");
    }
    quit(1, "OK");
    return 0;
}



























